Bug 280381 - RHEL4.6: Add missing AD1984 HDAudio codec support
RHEL4.6: Add missing AD1984 HDAudio codec support
Status: CLOSED ERRATA
Product: Red Hat Enterprise Linux 4
Classification: Red Hat
Component: kernel (Show other bugs)
4.6
All Linux
high Severity high
: ---
: ---
Assigned To: Brian Maly
Martin Jenner
: FutureFeature, OtherQA
Depends On:
Blocks: 221318 351911
  Show dependency treegraph
 
Reported: 2007-09-06 08:58 EDT by Bhavna Sarathy
Modified: 2009-06-19 20:51 EDT (History)
7 users (show)

See Also:
Fixed In Version: RHBA-2007-0791
Doc Type: Enhancement
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2007-11-15 11:32:16 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
AD1984 Codec backport (11.61 KB, patch)
2007-09-13 09:31 EDT, Bhavna Sarathy
no flags Details | Diff
dmsg when failed to load snd_azx module (18.21 KB, text/plain)
2007-09-14 01:34 EDT, Shane Huang
no flags Details
compile warnings (734 bytes, text/plain)
2007-09-14 01:35 EDT, Shane Huang
no flags Details
strace log to "aplay KDE_Startup.wav" (11.89 KB, text/plain)
2007-09-21 07:05 EDT, Shane Huang
no flags Details
strace log to "aplay startup3.wav" (11.35 KB, text/plain)
2007-09-21 07:06 EDT, Shane Huang
no flags Details

  None (edit)
Description Bhavna Sarathy 2007-09-06 08:58:45 EDT
Description of problem:
Our Trevally board use AD1984 as it's HDAudio codec chip/PCM device,
But I find that the driver of AD1984 is NOT added into RHEL4.6 Beta
(the SB700/SB600 Azalia controller driver has been included).
So there is NO audio output after RHEL4.6 Beta fresh installation.
Comment 1 Andrius Benokraitis 2007-09-12 13:31:22 EDT
Bhavana, are you saying this was originally in a previous RHEL 4 release or that
the AD1984 support is new?
Comment 2 Bhavna Sarathy 2007-09-13 09:31:22 EDT
Created attachment 194671 [details]
AD1984 Codec backport

Shane, please test this patch from Red Hat on the Trevally board.   The build
errors are fixed.
Comment 3 Bhavna Sarathy 2007-09-13 09:35:55 EDT
RHEL5.1 and RHEL4.6 support SB700 chipset: two things
1) maintain the same SW support across a RHEL5 and a RHEL4 releases
2) AMD Chipset team found that RHEL5.1 has the audio support and RHEl4.6 does not.

Brian Maly has provided a backport which the chipset team will test prior to
posting.
Comment 5 Shane Huang 2007-09-14 01:34:32 EDT
Created attachment 195581 [details]
dmsg when failed to load snd_azx module
Comment 6 Shane Huang 2007-09-14 01:35:08 EDT
Created attachment 195591 [details]
compile warnings
Comment 7 Shane Huang 2007-09-14 01:45:03 EDT
After I applied the new patch, when I compile the RHEL4.6 Snapshot kernel
(2.6.9-57.EL), there are two warnings, and the module snd-azx is unable to
be loaded. please check the above two attachments.

The module load problem and the first compile warning can be fixed by
adding the include file <linux/mutex.h> into new sound/pci/azx/patch_analog.c
But there is still NO audio output after the load of snd-azx.ko

My test method:
1. Compile and boot the new kernel after the patch;
2. Use the GUI tool "Soundcard Detection" to detect audio output;
3. If 2 is failed, manually use aplay program to play and test some .wav files.

If you have better test methods, please tell me.

I also have tried to build alsa-lib and alsa-utils, but in vain.
there is compile errors in alsa-utils-1.0.14
Comment 8 Bhavna Sarathy 2007-09-17 16:17:52 EDT
Try the following:

(1) make sure the sound card is recognized i.e. "aplay -l"

(2) make sure its not muted i.e. "alsaunmute -s 100"

(3) try a test sound i.e. "aplay /usr/share/sounds/phone.wav" 
Comment 10 Shane Huang 2007-09-18 01:55:04 EDT
I tried the above methods, finding that there is audio output after the patch,
BUT the audio is abnormal, when a ".wav" file is being played, usually there
are many(10 or more or endless) abnormal loops of middle PART of its audio,
which make the audio turn out to be NOISE, here are some examples:

[root@localhost ~]# aplay /usr/share/sounds/startup3.wav 
Playing WAVE '/usr/share/sounds/startup3.wav' : Signed 16 bit Little Endian, 
Rate 44100 Hz, Stereo
aplay: pcm_write:1115: write error: Input/output error

[root@localhost ~]# aplay XP_startup.wav 
Playing WAVE 'XP_startup.wav' : Signed 16 bit Little Endian, Rate 22050 Hz, 
Stereo
aplay: pcm_write:1115: write error: Input/output error

[root@localhost ~]# aplay /usr/share/sounds/KDE_Startup.wav 
Playing WAVE '/usr/share/sounds/KDE_Startup.wav' : Signed 16 bit Little 
Endian, Rate 22050 Hz, Mono
(comment by Shane: endless loop playing of KDE_Startup.wav)


BTW:
Sound card seems can be recognized correctly:
[root@localhost ~]# aplay -l
**** List of PLAYBACK Hardware Devices ****
card 0: SB [HDA ATI SB], device 0: AD198x Analog [AD198x Analog]
  Subdevices: 1/1
  Subdevice #0: subdevice #0
card 0: SB [HDA ATI SB], device 1: AD198x Digital [AD198x Digital]
  Subdevices: 1/1
  Subdevice #0: subdevice #0
[root@localhost ~]#
Comment 11 Shane Huang 2007-09-18 01:58:48 EDT
Brian & Bhavana:

Any solutions? :-)
Comment 12 Brian Maly 2007-09-20 16:08:29 EDT
Re: Comment #10, This may be a new and different problem alltogether.

Can you run strace on aplay and attach the output?
Comment 13 Shane Huang 2007-09-21 07:05:16 EDT
Created attachment 201911 [details]
strace log to "aplay KDE_Startup.wav"

strace log to "aplay KDE_Startup.wav"
Comment 14 Shane Huang 2007-09-21 07:06:12 EDT
Created attachment 201921 [details]
strace log to "aplay startup3.wav"
Comment 15 Shane Huang 2007-09-28 22:24:48 EDT
Hi Brian,
Is there some new progress on this issue? Thanks
Comment 18 Russell Doty 2007-10-02 12:59:20 EDT
Can we get a Dev ACK for this patch, with the understanding that the issues
raised in comment #10 will be addressed in a separate BZ?
Comment 23 Jason Baron 2007-10-10 15:16:02 EDT
committed in stream U6 build 62. A test kernel with this patch is available from
http://people.redhat.com/~jbaron/rhel4/
Comment 25 John Poelstra 2007-10-10 23:11:06 EDT
A fix for this issue should be included in the packages contained in
RHEL4.6-Snapshot6--available now on partners.redhat.com.  

Please verify that your issue is fixed ASAP to ensure that it is included in
this update release.

After you (Red Hat Partner) have verified that this issue has been addressed,
please perform the following:
1) Change the *status* of this bug to VERIFIED.
2) Add *keyword* of PartnerVerified (leaving the existing keywords unmodified)

If this issue is not fixed, please add a comment describing the most recent
symptoms of the problem you are having and change the status of the bug to FAILS_QA.

If you cannot access bugzilla, please reply with a message about your test
results to Issue Tracker.  If you need assistance accessing
ftp://partners.redhat.com, please contact your Partner Manager.
Comment 26 Shane Huang 2007-10-11 07:09:28 EDT
The codec on Trevally board does NOT work either with the 2.6.9-62 kernel.
There is no audio output after I upgrade kernel from -60 to -62, after I
do "Soundcard Detection", there is audio output, but it is wrong, the
phenomenon is same as the one in Comment #10. At this time, 
upgrading the alsa-driver to 1.0.14 manually can make the audio work.

As to the Snapshot6(-61 kernel), it has not been verified.
Comment 27 Bhavna Sarathy 2007-10-11 10:20:55 EDT
Brian Maly added the framework for quirks to RHEL4, so they can add a quirk for
this codec if needed.   Please look into the ALSA dev tree (1.0.15.rc3) and
identify the quirks that might make the proto boards work.
Comment 28 John Poelstra 2007-10-18 14:54:55 EDT
A fix for this issue should be included in the packages contained in 
RHEL4.6-Snapshot7--available now on partners.redhat.com.  

IMPORTANT: This is the last opportunity to confirm that your issue is fixed in 
the RHEL4.6 update release.

After you (Red Hat Partner) have verified that this issue has been addressed, 
please perform the following:
1) Change the *status* of this bug to VERIFIED.
2) Add *keyword* of PartnerVerified (leaving the existing keywords unmodified)

If this issue is not fixed, please add a comment describing the most recent 
symptoms of the problem you are having and change the status of the bug to 
FAILS_QA.

If you cannot access bugzilla, please reply with a message about your test 
results to Issue Tracker.  If you need assistance accessing 
ftp://partners.redhat.com, please contact your Partner Manager.
Comment 29 Yang, Libin 2007-10-19 03:19:27 EDT
We have test RHEL4.6 snapshot7. The issue still exists. Please refer comment #10
for the symptoms.
Comment 30 Russell Doty 2007-10-19 09:57:55 EDT
We believe that we have addressed the issue with the AD1984 HDAudio codec. Do
you have any other systems with the AD1984 HDAudio codec that you can test?

We need to open another BZ to address the issues with the Trevally board - we
understand that audio still does not work correctly on this board, but believe
the remaining issues are not directly tied to the AD1984 HDAudio codec.
Comment 32 Russell Doty 2007-10-24 11:25:55 EDT
Removed from RHEL 4.7 tracker. A new BZ needs to be opened for the Trevally
board. This BZ is for the AD1984 codec only.
Comment 33 Shane Huang 2007-10-25 22:34:21 EDT
the new BZ for Trevally has been created, please check BZ# 351911.
Comment 35 errata-xmlrpc 2007-11-15 11:32:16 EST
An advisory has been issued which should help the problem
described in this bug report. This report is therefore being
closed with a resolution of ERRATA. For more information
on the solution and/or where to find the updated files,
please follow the link below. You may reopen this bug report
if the solution does not work for you.

http://rhn.redhat.com/errata/RHBA-2007-0791.html

Note You need to log in before you can comment on or make changes to this bug.